package com.sa.ibiz.demo.demoapp.controller.demo.vo;

import java.sql.Timestamp;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.Data;
import com.sa.ibiz.demo.demo.domain.OrgUserLevel;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import java.math.BigInteger;
import java.util.HashMap;
import java.util.Map;
import java.util.List;
import java.util.ArrayList;
import org.springframework.cglib.beans.BeanMap;
import com.alibaba.fastjson.JSONObject;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class OrgUserLevel_Grid_Main2{
    private String memo;
    private String updateman;
    private Integer ordervalue;
    private String levelcode;
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", timezone="GMT+8")
    private Timestamp updatedate;
    private String orguserlevelname;
    private String srfmajortext;


    private String srfdataaccaction;


    private String srfkey;


    private String orguserlevelid;
    private Integer validflag;
    public  void fromOrgUserLevel(OrgUserLevel sourceEntity)  {
         this.setMemo(sourceEntity.getMemo());
         this.setUpdateman(sourceEntity.getUpdateman());
         this.setOrdervalue(sourceEntity.getOrdervalue());
         this.setLevelcode(sourceEntity.getLevelcode());
         this.setUpdatedate(sourceEntity.getUpdatedate());
         this.setOrguserlevelname(sourceEntity.getOrguserlevelname());
         this.setSrfmajortext(sourceEntity.getOrguserlevelname());
         this.setSrfdataaccaction(sourceEntity.getOrguserlevelid());
         this.setSrfkey(sourceEntity.getOrguserlevelid());
         this.setOrguserlevelid(sourceEntity.getOrguserlevelid());
         this.setValidflag(sourceEntity.getValidflag());
	}

	public static Page<OrgUserLevel_Grid_Main2> fromOrgUserLevel(Page<OrgUserLevel> sourcePage)  {
        if(sourcePage==null)
            return null;
        Page<OrgUserLevel_Grid_Main2> targetpage=new Page<OrgUserLevel_Grid_Main2>(sourcePage.getCurrent(),sourcePage.getSize(),sourcePage.getTotal(),sourcePage.isSearchCount());
        List<OrgUserLevel_Grid_Main2> records=new ArrayList<OrgUserLevel_Grid_Main2>();
        for(OrgUserLevel source:sourcePage.getRecords()) {
            OrgUserLevel_Grid_Main2 target=new OrgUserLevel_Grid_Main2();
            target.fromOrgUserLevel(source);
            records.add(target);
        }
        targetpage.setAsc(sourcePage.ascs());
        targetpage.setDesc(sourcePage.descs());
        targetpage.setOptimizeCountSql(sourcePage.optimizeCountSql());
        targetpage.setRecords(records);
        return targetpage;
    }

    /**
     * 表格模型集合
     * @return
     */
    public static List<Map<String,String>> getGridColumnModels() {
        List columnModelList =new ArrayList();
        columnModelList.add(new HashMap(){ { put("orguserlevelname","人员级别名称"); }});
        columnModelList.add(new HashMap(){ { put("levelcode","级别代码"); }});
        columnModelList.add(new HashMap(){ { put("ordervalue","排序值"); }});
        columnModelList.add(new HashMap(){ { put("validflag","启用标志"); }});
        columnModelList.add(new HashMap(){ { put("memo","备注"); }});
        columnModelList.add(new HashMap(){ { put("updateman","更新人"); }});
        columnModelList.add(new HashMap(){ { put("updatedate","更新时间"); }});
        return columnModelList;
    }

    /**
     *将entity转成map
     * @param bean
     * @param <T>
     * @return
     */
    public <T> Map<String,Object> beanToMap(T bean){
        Map map =new HashMap<String,Object>();
        if(bean!=null){
            BeanMap beanMap=BeanMap.create(bean);
            for(Object obj:beanMap.keySet()){
                map.put(obj+"",beanMap.get(obj));
            }
        }
        return map;
    }

    /**
     * 将entity转成map
     * @param searchResult
     * @return
     */
    public static List<Map<String, Object>> pageToListDatas(Page<OrgUserLevel> searchResult) {
        if(searchResult==null)
            return null;
        List<Map<String, Object>> records=new ArrayList<>();
        for(OrgUserLevel source:searchResult.getRecords()) {
            OrgUserLevel_Grid_Main2 target=new OrgUserLevel_Grid_Main2();
            records.add(target.beanToMap(source));
        }
        return records;
    }

    /**
     * 输出表格数据导出文件url
     * @param sourcePage
     * @param downloadurl
     * @return
     */
    public static Page<JSONObject> getResultPage(Page<OrgUserLevel> sourcePage,String downloadurl)  {
        if(sourcePage==null)
            return null;
        Page<JSONObject> targetpage=new Page<JSONObject>(sourcePage.getCurrent(),sourcePage.getSize(),sourcePage.getTotal(),sourcePage.isSearchCount());
        List<JSONObject> records=new ArrayList<JSONObject>();
        JSONObject obj =new JSONObject();
        obj.put("downloadurl",downloadurl);
        records.add(obj);
        targetpage.setAsc(sourcePage.ascs());
        targetpage.setDesc(sourcePage.descs());
        targetpage.setOptimizeCountSql(sourcePage.optimizeCountSql());
        targetpage.setRecords(records);
        return targetpage;
    }


}